﻿"use strict";

var WingtipToys = window.WingtipToys || {};

$(document).ready(function () {

    //query parameters
    var params = document.URL.split("?")[1].split("&");
    var senderId = "";
    var view = "month";
    for (var i = 0; i < params.length; i = i + 1) {
        var singleParam = params[i].split("=");
        if (singleParam[0].toLowerCase() === "senderid") {
            senderId = decodeURIComponent(singleParam[1]);
        }
        if (singleParam[0].toLowerCase() === "view") {
            view = decodeURIComponent(singleParam[1]);
        }
    }

    //Get any included paths
    WingtipToys.Paths.read_all().then(

        //Get any included calendar paths
        function (data) {
            var results = data.d.results;
            var paths = [];
            for (var i = 0; i < results.length; i++) {
                paths.push(results[i].URL.Url);
            }

            //Load the calendar
            var calendarView = view;
            if (calendarView === "smallMonth") {
                calendarView = "month";
            }
            WingtipToys.Events.load(90, 365, paths).then(
                function (data) {
                    $("#corporateCalendar").fullCalendar({
                        events: WingtipToys.Events.get_formattedEvents(),
                        defaultView: calendarView,
                        weekends: false
                    });
                },
                function (err) {
                    alert(JSON.stringify(err));
                }
            );

            //Resize the window
            switch (view) {
                case "month":
                    window.parent.postMessage("<message senderId=" + senderId + ">resize(840,660)</message>", "*");
                    break;
                case "smallMonth":
                    window.parent.postMessage("<message senderId=" + senderId + ">resize(420,330)</message>", "*");
                    break;
                case "basicWeek":
                    window.parent.postMessage("<message senderId=" + senderId + ">resize(840,330)</message>", "*");
                    break;
                case "basicDay":
                    window.parent.postMessage("<message senderId=" + senderId + ">resize(420,330)</message>", "*");
                    break;
                case "agendaWeek":
                    window.parent.postMessage("<message senderId=" + senderId + ">resize(840,330)</message>", "*");
                    break;
                case "agendaDay":
                    window.parent.postMessage("<message senderId=" + senderId + ">resize(420,330)</message>", "*");
                    break;

            }

        },

        function (err) {
            alert(JSON.stringify(err));
        }
    );

});


