﻿var SHTSLLC = SHTSLLC || {};

SHTSLLC.Setting = function (id, key, value) {

    var i = id,
        k = key,
        v = value,

        get_id = function () { return i; },
        set_id = function (x) { i = x; },
        get_key = function () { return k; },
        set_key = function (x) { k = x; },
        get_value = function () { return v; },
        set_value = function (x) { v = x; };

    return {
        get_id: get_id,
        set_id: set_id,
        get_key: get_key,
        set_key: set_key,
        get_value: get_value,
        set_value: set_value
    }
}

SHTSLLC.Settings = function () {

    var settings = [],

    init = function () {
        //Save new setting when selected in list
        $("#viewSelector").live("change", function () {
            var printViewSettingVal = $("#viewSelector option:selected").first().attr("value");
            updateSetting("PrintView", printViewSettingVal);
        });
    },

    readSettings = function () {
        //Read all setitngs from the list
        $.ajax(
                {
                    url: _spPageContextInfo.webServerRelativeUrl +
                        "/_api/web/lists/getByTitle('Settings')/items/" +
                        "?$select=Id,Title,Value",
                    type: "GET",
                    headers: {
                        "accept": "application/json;odata=verbose",
                    },
                    success: function (data) {

                        //Save the settings
                        settings = [];
                        var results = data.d.results;
                        for (var i = 0; i < results.length; i++) {
                            settings.push(
                                new SHTSLLC.Setting(
                                results[i].Id,
                                results[i].Title,
                                results[i].Value));
                        }

                        //Update the UI with the current settings
                        var printViewSetting = readSetting("PrintView");
                        $("#viewSelector option").attr("selected", "");
                        $("#viewSelector option[value='" + printViewSetting.get_value() + "']").attr("selected", "selected");

                    },
                    error: function (err) {
                        alert(JSON.stringify(err));
                    }
                }
            );
    },

    readSetting = function (key) {
        //Read a setting using the key
        var setting;
        for (var i = 0; i < settings.length; i++) {
            if (settings[i].get_key() === key) {
                setting = settings[i];
            }
        }
        return setting;
    },

    updateSetting = function (key, value) {

        $("#updatingImg").show();

        //Write setting back to the list
        $.ajax(
                {
                    url: _spPageContextInfo.webServerRelativeUrl +
                        "/_api/web/lists/getByTitle('Settings')/getItemByStringId('" +
                        readSetting(key).get_id() + "')",
                    type: "POST",
                    contentType: "application/json;odata=verbose",
                    data: JSON.stringify(
                    {
                        '__metadata': {
                            'type': 'SP.Data.SettingsListItem'
                        },
                        'Title': key,
                        'Value': value
                    }),
                    headers: {
                        "accept": "application/json;odata=verbose",
                        "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                        "IF-MATCH": "*",
                        "X-Http-Method": "PATCH"
                    },
                    success: function (data) {
                        $("#updatingImg").hide();
                    },
                    error: function (err) {
                        alert(JSON.stringify(err));
                    }
                }
            );
    };

    return {
        init: init,
        readSettings: readSettings,
        readSetting: readSetting,
        updateSetting: updateSetting
    }

}();

$(document).ready(function () {
    SHTSLLC.Settings.init();
    SHTSLLC.Settings.readSettings();
});