﻿"use strict";
var ToDo = window.ToDo || {};

ToDo.App.controller("editCtrl", ["$scope", "$routeParams", "$location", "$http",
     function editCtrl($scope, $routeParams, $location, $http) {

         "use strict";
         jQuery("title").text("Edit Item" + $routeParams.id);

         //view model
         $scope.item = {
             id: "",
             title: "",
             priority: "",
             status: "",
             dueDate: ""
         };

         $http({
             url: "../_api/lists/getbyTitle('todo')/getItemByStringId('" + $routeParams.id + "')",
             params:{
                 "$select": "ID,Title,Priority,Status,DueDate"
             },
             method: "GET",
             headers: {
                 "accept": "application/json;odata=verbose",
             }
         }).success(function (data, status, headers, config) {

             //fill model
             var dt = new Date(data.d.DueDate);

             $scope.item = {
                 id: data.d.ID,
                 title: data.d.Title,
                 priority: data.d.Priority,
                 status: data.d.Status,
                 dueDate: ((dt.getMonth() + 1) + "/" + dt.getDate() + "/" + dt.getFullYear())
             };

         }).error(function (data, status, headers, config) {
             alert(JSON.stringify(data));
         });

         //update item
         $scope.updateItem = function (id) {
             $http({
                 url: "../_api/lists/getbyTitle('todo')/getItemByStringId('" + $routeParams.id + "')",
                 method: "POST",
                 data: JSON.stringify({
                     __metadata: { "type": "SP.Data.TodoListItem" },
                     Title: $scope.item.title,
                     Priority: $scope.item.priority,
                     Status: $scope.item.status,
                     DueDate: $scope.item.dueDate
                 }),
                 headers: {
                     "content-type": "application/json;odata=verbose",
                     "accept": "application/json;odata=verbose",
                     "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                     "IF-MATCH": "*",
                     "X-Http-Method": "PATCH"
                 }
             }).success(function (data, status, headers, config) {
                 $location.path("/");
                 $scope.$apply();
             }).error(function (data, status, headers, config) {
                 alert(JSON.stringify(data));
             });
         }

     }
]);