﻿"use strict";
var ToDo = window.ToDo || {};

ToDo.App.controller("homeCtrl", ["$scope", "$location", "$http",
    function homeCtrl($scope, $location, $http) {

        "use strict";
        jQuery("title").text("Home");

        //view model
        $scope.items = [];

        //Load all items
        var loadItems = function () {
            $http({
                url: "../_api/lists/getbyTitle('todo')/items",
                params: {
                    "$select": "ID,Title,Priority,Status,DueDate",
                    "$ordeby": "DueDate"
                },
                method: "GET",
                headers: {
                    "accept": "application/json;odata=verbose",
                }
            }).success(function (data, status, headers, config) {

                //fill model
                var results = data.d.results;
                $scope.items = [];
                for (var i = 0; i < results.length; i++) {
                    var dt = new Date(results[i].DueDate);
                    var item = {
                        id: results[i].ID,
                        title: results[i].Title,
                        priority: results[i].Priority,
                        status: results[i].Status,
                        dueDate: ((dt.getMonth() + 1) + "/" + dt.getDate() + "/" + dt.getFullYear())
                    };
                    $scope.items.push(item);
                }


            }).error(function (data, status, headers, config) {
                alert(JSON.stringify(data));
            });
        }
        loadItems();

        //delete
        $scope.deleteTodo = function (id) {
            $http(
                {
                    url: "../_api/lists/getbyTitle('todo')/getItemByStringId('" + id + "')",
                    method: "DELETE",
                    headers: {
                        "accept": "application/json;odata=verbose",
                        "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                        "IF-MATCH": "*"
                    }
                }).success(function (data, status, headers, config) {
                    loadItems();
                }).error(function (data, status, headers, config) {
                    alert(JSON.stringify(data));
                });
        };
    }
]);
